*************************************************************************
* filename: rqst_gnr.prg                                                *
* revised:  2/12/94                                                     *
* purpose : Set up reports to be processed by RPT_SERV                  *
*************************************************************************
* windows  : wmenu
*
*
*******************************************************************************
* PREFACE: Welcome to RQST_GNR.PRG! This program allows you to run      *
*          reports concurrently with your other processing.  The        *
*          principle is simple: This program, RQST_GNR.PRG, will        *
*          generate the necessary parameters to run a report. Another   *
*          program, RPT_SERV.PRG, retrieves these parameters from the   *
*          database REQUESTS.DBF and processes the requested report     *
*          from them.  The two programs, RQST_GNR.PRG and RPT_SERV.PRG, *
*          typically run concurrently on different computers on the     *
*          same network.  After a report request is initiated by        *
*          RQST_GNR.PRG the work station is immediately available for   *
*          another task while the report processing can begin almost    *
*          immediately under the control of RPT_SERV.PRG running        *
*          on another work station. Another configuration is both       *
*          programs run on a standalone computer: RQST_GNR.PRG during   *
*          the normal work day and RPT_SERV.PRG after hours to run      *
*          reports over night.                                          *
*                                                                       *
*          RPT_SERV.PRG and RQST_GNR.PRG are necessarily incomlete      *
*          programs. You must define such things as the procedure       *
*          file, pathnames, etc. Where such items must be defined       *
*          a comment of the form **^^** is inserted to alert you        *
*          to the need to insert custom coding.                         *
*                                                                       *
*          The requests database is the file RPT_RQST.DBF:              *
*                                                                       *
*         Field Name      Type  Len Comments                            *
*           1   P_LEVEL    C      1 Priority level of the request.      *
*           2   DT_AND_TM  C     14 Date and time of the request as     *
*                                   YYYYMMDDHHMMSS (year-month-day-     *
*                                   hour-minute-second)                 *
*           3   PRG_MOD    C      8 Program module that will prepare    *
*                                   and print the report.               *
*           4   RPT_SPCS   M     10 Memo field containing the variable  *
*                                   specifications for the report.      *
*           5   DATA_PATH  C     20 Network drive resource which is     *
*                                   the default source of report data.  *
*                                                                       *
*         RPT_RQST is indexed on P_LEVEL + DT_AND_TM to RPT_RQST.IDX.   *
*                                                                       *
*         An example report included with this distribution is the      *
*         printing of a customer list.  The included database for it,   *
*         CSTMERS.DBF, has the following structure:                     *
*                                                                       *
*         Field Name      Type  Len Comments                            *
*             1 CUST_NO     C     8 Customer number
*             2 COMPANY     C    30 Customer Name                       *
*             3 ADDR1       C    25 First address line                  *
*             4 ADDR2       C    25 Second address line                 *
*             5 CITY        C    25 City                                *
*             6 STATE       C     2 State                               *
*             7 ZIP         C    10 Zip code                            *
*             8 SALES       N     2 Sales territory assigned to         *
*                                                                       *
*          CSTMERS is indexed on CUST_NO to tag CUST_NO and on          *
*                                COMPANY to tag COMPANY of CSTMERS.CDX  *
*                                                                       *
*                                                                       *
*          If you find these programs to be useful and want to          *
*          continue using them, please register with:                   *
*                                                                       *
*               COMPUTER PRODUCTS implementation                        *
*               6443 Wilkinson Avenue                                   *
*               North Hollywood,  CA  91606                             *
*                    (818) 762-0380                                     *
*          for a registration fee of $25.00 U.S.A. currency             *
*                                                                       *
*          For advice and assistance in getting your report server      *
*          in operation, feel free to contact the author: John Ferguson *
*          COMPUSERVE ID 73052,2675                                     *
*                                                                       *
*          Happy reporting with RPT_SERV.PRG and RQST_GNR.PRG!          *
*                                                                       *
CLOSE ALL
* set runtime environment *
SET STATUS OFF
SET TALK OFF
SET BELL OFF
SET SCORE OFF
SET SAFETY ON
SET CONFIRM OFF
SET DATE AMERICAN
SET CENTURY OFF
* set local colors *
fore       =  'w+' && foreground color.
back       =  'r'  && background color.
scrn       =  'w'  && screen color.
* define local menu window *
DEFINE WINDOW wmenu FROM 4,22 TO 15,72;
 SHADOW ;
 TITLE ' REPORT SERVER REQUESTS ';
 COLOR &fore/&back

SELECT 0
USE rpt_rqst ALIAS rqst INDEX rpt_rqst

DO WHILE .T.
  * open local menu window *
  ACTIVATE WINDOW wmenu
  SET COLOR TO &fore/&back,n/w
  mopt = 9
  @  1, 4 PROMPT ' A>  CUSTOMER LIST                    ' ;
   MESSAGE 'List Customers for choice of territory and sequence'
      && report driver is CST_LST
**^^** add as many prompts as you need to support the reports you will
**^^** be requesting.
  @  9, 4 PROMPT ' I>  RETURN                           ' ;
   MESSAGE 'Return to Previous (System Reports) Menu'
  MENU TO mopt
  DEACTIVATE WINDOW wmenu
  DO CASE

  CASE mopt = 1   &&  Customer list
    CLEAR
    mterr = 0
    mseq = 2
    @ 10,10 SAY 'Territory (0 for all)' GET mterr PICTURE '99'
    @ 12,10 SAY 'Sequence: (1 for Number, 2 for Name)' GET mseq PICTURE '9' ;
          VALID BETWEEN ( mseq , 1 , 2 )
    READ
    SELECT rqst
    SEEK 'a'            && fetch an available record
    IF NOT FOUND()
      APPEND BLANK
    ENDIF
    REPLACE p_level WITH '3'    && **^^** this is an arbitrary priority
    mtime = TIME()
    REPLACE dt_and_tm WITH DTOS( DATE () ) + SUBSTR ( mtime , 1 , 2 ) + ;
      SUBSTR ( mtime , 4 , 2 ) + SUBSTR ( mtime , 7 )
    REPLACE prg_mod WITH "cst_lst"
    mspecs = STR ( mterr , 1 ) + [,] + STR ( mseq , 1 )
    **^^**  since the field rpt_spcs is a memo field, you should set it
    **^^**  it up in a memory variable first.  mspecs could look like
    **^^**  '1,3'
    REPLACE rpt_spcs WITH mspecs
    **^^**  if you had to pass the variables xx (character), yy (date), and
    **^^**  zz (logical), and ww (numeric) you could set up mspec as follows:
    **^^**  mspec = ["] + xx + [" , {] + DTOC ( yy ) + [} , .] + ;
                    IIF ( zz , "T" , "F" ) + [. , ] + STR ( ww , 5 , 2 )
    **^^**  note that all parameters to be passed must be a character type
    **^^**  but when passed as a macro variable by rpt_serv.prg, they will
    **^^**  appear to the report driver as the required types.

  CASE mopt = 9 OR mopt = 2
   * close menu window *
   RELEASE WINDOW wmenu
   CLOSE DATABASES
   CLEAR
   EXIT

  ENDCASE
ENDDO
RETURN

*****           eof: rqst_gnr.prg                                   *****

